<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReversalByMerchantTranId StructType
 * @subpackage Structs
 */
class ReversalByMerchantTranId extends AbstractStructBase
{
    /**
     * The inMerchantTranId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $inMerchantTranId;
    /**
     * The inIssuerMerchantId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $inIssuerMerchantId;
    /**
     * The inTerminalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $inTerminalId;
    /**
     * The inAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $inAmount;
    /**
     * Constructor method for ReversalByMerchantTranId
     * @uses ReversalByMerchantTranId::setInMerchantTranId()
     * @uses ReversalByMerchantTranId::setInIssuerMerchantId()
     * @uses ReversalByMerchantTranId::setInTerminalId()
     * @uses ReversalByMerchantTranId::setInAmount()
     * @param string $inMerchantTranId
     * @param int $inIssuerMerchantId
     * @param string $inTerminalId
     * @param int $inAmount
     */
    public function __construct($inMerchantTranId = null, $inIssuerMerchantId = null, $inTerminalId = null, $inAmount = null)
    {
        $this
            ->setInMerchantTranId($inMerchantTranId)
            ->setInIssuerMerchantId($inIssuerMerchantId)
            ->setInTerminalId($inTerminalId)
            ->setInAmount($inAmount);
    }
    /**
     * Get inMerchantTranId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInMerchantTranId()
    {
        return isset($this->inMerchantTranId) ? $this->inMerchantTranId : null;
    }
    /**
     * Set inMerchantTranId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $inMerchantTranId
     * @return \StructType\ReversalByMerchantTranId
     */
    public function setInMerchantTranId($inMerchantTranId = null)
    {
        // validation for constraint: string
        if (!is_null($inMerchantTranId) && !is_string($inMerchantTranId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inMerchantTranId, true), gettype($inMerchantTranId)), __LINE__);
        }
        if (is_null($inMerchantTranId) || (is_array($inMerchantTranId) && empty($inMerchantTranId))) {
            unset($this->inMerchantTranId);
        } else {
            $this->inMerchantTranId = $inMerchantTranId;
        }
        return $this;
    }
    /**
     * Get inIssuerMerchantId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getInIssuerMerchantId()
    {
        return isset($this->inIssuerMerchantId) ? $this->inIssuerMerchantId : null;
    }
    /**
     * Set inIssuerMerchantId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $inIssuerMerchantId
     * @return \StructType\ReversalByMerchantTranId
     */
    public function setInIssuerMerchantId($inIssuerMerchantId = null)
    {
        // validation for constraint: int
        if (!is_null($inIssuerMerchantId) && !(is_int($inIssuerMerchantId) || ctype_digit($inIssuerMerchantId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($inIssuerMerchantId, true), gettype($inIssuerMerchantId)), __LINE__);
        }
        if (is_null($inIssuerMerchantId) || (is_array($inIssuerMerchantId) && empty($inIssuerMerchantId))) {
            unset($this->inIssuerMerchantId);
        } else {
            $this->inIssuerMerchantId = $inIssuerMerchantId;
        }
        return $this;
    }
    /**
     * Get inTerminalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInTerminalId()
    {
        return isset($this->inTerminalId) ? $this->inTerminalId : null;
    }
    /**
     * Set inTerminalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $inTerminalId
     * @return \StructType\ReversalByMerchantTranId
     */
    public function setInTerminalId($inTerminalId = null)
    {
        // validation for constraint: string
        if (!is_null($inTerminalId) && !is_string($inTerminalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($inTerminalId, true), gettype($inTerminalId)), __LINE__);
        }
        if (is_null($inTerminalId) || (is_array($inTerminalId) && empty($inTerminalId))) {
            unset($this->inTerminalId);
        } else {
            $this->inTerminalId = $inTerminalId;
        }
        return $this;
    }
    /**
     * Get inAmount value
     * @return int|null
     */
    public function getInAmount()
    {
        return $this->inAmount;
    }
    /**
     * Set inAmount value
     * @param int $inAmount
     * @return \StructType\ReversalByMerchantTranId
     */
    public function setInAmount($inAmount = null)
    {
        // validation for constraint: int
        if (!is_null($inAmount) && !(is_int($inAmount) || ctype_digit($inAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($inAmount, true), gettype($inAmount)), __LINE__);
        }
        $this->inAmount = $inAmount;
        return $this;
    }
}
